"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _identity2 = _interopRequireDefault(require("ramda/src/identity"));

var _react = require("@storybook/react");

var _util = require("./lib/util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var mdDefaultOptions = {
  storySubFuncList: [],
  contentFuncList: [_identity2.default],
  hierarchyRoot: '',
  groupByFolder: true,
  folderNameWhenEmpty: 'ALL',
  thirdParamMaker: null,
  dotFolderName: '.'
};

function loadStories(loader, requireContext) {
  var userOptions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var isContentAComponent = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

  var _mdDefaultOptions$use = _objectSpread({}, mdDefaultOptions, userOptions),
      storySubFuncList = _mdDefaultOptions$use.storySubFuncList,
      hierarchyRoot = _mdDefaultOptions$use.hierarchyRoot,
      contentFuncList = _mdDefaultOptions$use.contentFuncList,
      folderNameWhenEmpty = _mdDefaultOptions$use.folderNameWhenEmpty,
      thirdParamMaker = _mdDefaultOptions$use.thirdParamMaker,
      dotFolderName = _mdDefaultOptions$use.dotFolderName,
      loaderOptions = _objectWithoutProperties(_mdDefaultOptions$use, ["storySubFuncList", "hierarchyRoot", "contentFuncList", "folderNameWhenEmpty", "thirdParamMaker", "dotFolderName"]);

  var groupByFolder = loaderOptions.groupByFolder;
  (0, _util.toList)(requireContext).forEach(function (req) {
    // read files' contents
    var contentObj = loader(req, loaderOptions); // flatten folder layer

    var folderBaseContentList = (0, _util.flattenContentObj)(contentObj, groupByFolder);
    folderBaseContentList.forEach(function (_ref) {
      var _ref2 = _slicedToArray(_ref, 2),
          folderName = _ref2[0],
          contentList = _ref2[1];

      var subFolderName = folderName;

      if (subFolderName === '') {
        subFolderName = folderNameWhenEmpty;
      } else if (subFolderName === '.') {
        subFolderName = dotFolderName;
      }

      var stories = (0, _react.storiesOf)("".concat(hierarchyRoot).concat(subFolderName), module); // apply option functions of storybook

      (0, _util.applySubFuncs)(stories, storySubFuncList);
      contentList.forEach(function (_ref3) {
        var _ref4 = _slicedToArray(_ref3, 2),
            filePath = _ref4[0],
            _ref4$ = _slicedToArray(_ref4[1], 2),
            fileName = _ref4$[0],
            fileContent = _ref4$[1];

        var secondParam;

        if (!isContentAComponent) {
          secondParam = (0, _util.applyFuncList)(fileContent, contentFuncList);
        } else {
          var Component = (0, _util.applyFuncList)((0, _util.getComponent)(fileContent), contentFuncList);
          secondParam = (0, _util.toReact)(Component);
        }

        var thirdParam;

        if (thirdParamMaker) {
          thirdParam = thirdParamMaker(req, filePath);
        }

        stories.add(fileName, secondParam, thirdParam);
      });
    });
  });
}

var _default = loadStories;
exports.default = _default;
module.exports = exports.default;