"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _mdLoader = _interopRequireDefault(require("./mdLoader"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function formatWithNotesObject(content) {
  return {
    notes: {
      markdown: content
    }
  };
}

var defaultThirdParamOptions = {
  loader: _mdLoader.default,
  formatter: formatWithNotesObject
};

function createMDThirdParamMaker() {
  var userOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var _defaultThirdParamOpt = _objectSpread({}, defaultThirdParamOptions, userOptions),
      loader = _defaultThirdParamOpt.loader,
      formatter = _defaultThirdParamOpt.formatter;

  var reqCache = {};

  function thirdParamMaker(req, filePath) {
    // get from cache
    var key = req.id;

    if (!reqCache[key]) {
      reqCache[key] = loader(req, {
        groupByFolder: false
      });
    }

    var _ref = reqCache[key][filePath] || ['', ' '],
        _ref2 = _slicedToArray(_ref, 2),
        content = _ref2[1];

    return formatter(content);
  }

  return thirdParamMaker;
}

var _default = createMDThirdParamMaker;
exports.default = _default;
module.exports = exports.default;